
//============================================================================
// MODELE DE PLUGIN POUR PHOTOFILTRE ECRIT AVEC BORLAND C++ 5.02  (option C node)
//
// ENTETE POUR BC5 => A REVOIR POUR AUTRE COMPILATEUR
#define DLLEXPORT __declspec(dllexport)	// BC5 Fonctions Exportees
#define STRICT
#define WIN32
#pragma warning(disable:4505)
#pragma hdrstop
// IMPORTANT => 	Calling Convention = StdCall
//                Type de projet Dll 32 Bits standard (Platform:Win32 Target:GUI)
//						Link = "Static Mode" sinon le compilateur ne linkera pas le runtime C
//============================================================================


// INCLUSION HEADERS
#include <windows.h>
#include <windowsx.h>
#include "Ressources.h"
#include "democ.h"


// PROTOTYPES
BOOL WINAPI DllEntryPoint(HINSTANCE hinstDll,DWORD dwReason,LPVOID plvReserved);
extern struct PluginHeader* DLLEXPORT RegisterPluginHeader(void);
extern struct PluginStruct* DLLEXPORT RegisterPluginStruct(void);
extern int DLLEXPORT RegisterCompatibility(void);
extern int DLLEXPORT Execute(void);
extern HBITMAP DLLEXPORT RegisterPluginGlyph(void);
BOOL DialogProc(HWND hWin,UINT uMsg,WPARAM wParam,LPARAM lParam);
void Affiche(void);

//  VARIABLES GLOBALES
HINSTANCE hInstance;
struct PluginHeader	PHeader;
struct PluginStruct	PStruct;
struct SIMAGE Img;

// SPECIFIQUE PLUGIN
HWND	hDlg;     // Handle DialogBox
INT		Couche; 	// Masque de couche
INT		RetValue; // Retour de la boucle de message
INT		IsInit;		// Autorise/interdit l'affichage
HWND	HROUGE;		// Handle ChekBox Rouge
HWND	HVERT;		// Handle ChekBox Vert
HWND	HBLEU;		// Handle ChekBox Bleu


// DESCRIPTEURS PLUGIN
char HeaderCaption[] = {"Demo Filtre (C)"};
char HeaderVersion[] = {"Version 1.0"};
char HeaderAuthor[] =  {"P@F"};
char HeaderCommentaire[] = {"Conserve ou efface les couches R-V-B.\xA\xD"
														"Plugin de test crit en C.\xA\xD"
                            "Ncessite PhotoFiltre 5.6 minimum."};
int HeaderPluginType = PT_FILTER;
int HeaderPluginFlag = MF_RGB_COLORS + MF_NEED_IMAGE;

//=========================================================================
// POINT D'ENTREE DU PLUGIN
//=========================================================================
#pragma argsused  // Pour eviter le warning: Parameter '' is never used
BOOL WINAPI DllEntryPoint(HINSTANCE hinstDll,DWORD dwReason,LPVOID plvReserved)
{
if (dwReason == DLL_PROCESS_ATTACH) // Raison d'appel
	{
  hInstance = hinstDll; 	// Recupere l'instance dll du plugin
  // Les structures a zero
	ZeroMemory(&PStruct,sizeof(struct PluginStruct));	// Les structures a zero
  ZeroMemory(&PHeader,sizeof(struct PluginHeader));
  ZeroMemory(&Img,sizeof(struct SIMAGE));
  // Intialisation de la structure d'entete du plugin
	strcpy(PHeader.Caption,HeaderCaption);
	strcpy(PHeader.Version,HeaderVersion);
	strcpy(PHeader.Author,HeaderAuthor);
	strcpy(PHeader.Commentaire,HeaderCommentaire);
	PHeader.PluginType=HeaderPluginType;
	PHeader.Flags=HeaderPluginFlag;
	return(1);	// C'est tout bon !
  }
else
	return(0);	// Les autres raisons d'appel => Niet !
}

//=========================================================================
// FONCTION D'EXECUTION DU PLUGIN
//=========================================================================
extern int DLLEXPORT Execute(void)
{
//==== TEST DE LA VERSION PHOTOFILTRE ET DE LA COMPATIBILITE
// Si RegisterCompatibility retourne 1 ou la version ne gere pas
// la compatibilit niveau 2 => les fonctions niveau 2 sont initialises a zro
if (PStruct.TPrepareDialogue == 0)
	{
   MessageBox(NULL,
		"Ce plugin est incompatible avec cette version de PhotoFiltre.\xD\xA"
    "Il Ncessite la version 5.6 minimum.\xD\xA"
    "Vous pouver la tlcharger sur le site officiel:\xD\xA"
    "http://www.photofiltre.com/","Ancienne version de PhotoFiltre",
    MB_OK | MB_ICONINFORMATION);
   return(0); // Une petite MsgBox pour etre poli !
   };

//==== DEBUT DU FILTRE (Pour le curseur "sablier" => mettre 1 au lieu de dFALSE
(*PStruct.TBeginFilter)(HeaderCaption,dFALSE); // Signaler le debut a PhotoFiltre
// Lancer Visuel avec hParent = NUL => on laisse PhotoFiltre gerer le mode Modal
DialogBox(hInstance, MAKEINTRESOURCE(IDD_MAIN),NULL,DialogProc); // Lancer Visuel

//==== FIN DU FILTRE
(*PStruct.TEndFilter)(); // Signaler la fin a PhotoFiltre

//==== LIBERE L'IMAGE
if ( Img.piBitmap != NULL) // Un petit test pour eviter toute mauvaise surprise
	(*PStruct.TFreeDBmp)(&Img);

return(RetValue); // Valeur retourne par le Visuel (1=Modif, 0=NoModif)
}

//=========================================================================
// DialogProc  => Visuel
// Boucle de message de la boite de dialogue
//=========================================================================
#pragma argsused  // Pour eviter le warning: Parameter '' is never used
BOOL CALLBACK DialogProc(HWND hWin,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
switch(uMsg)
	{
   case WM_INITDIALOG:
   	//== Init VARIABLES ============================
		hDlg = hWin;						// Handle de la boite de dialogues
		IsInit = 0; 						// Interdire l'affichage pour le momment
		Couche = 0;             // Masque de couche
		RetValue = 0;						// Image non modifie
		Img.piBitmap = NULL;		// Pour etre sur de l'allocation future...

   	//== Init DIALOGBOX ============================
   	SendMessage(hWin,WM_SETICON,ICON_BIG,(LPARAM)LoadIcon(hInstance,(LPSTR)500));

   	//== Init CHECKBOX ============================
   	HROUGE = GetDlgItem(hWin,IDC_ROUGE); 	// Rouge
   	HVERT = GetDlgItem(hWin,IDC_VERT); 		// Vert
   	HBLEU = GetDlgItem(hWin,IDC_BLEU); 		// Bleu
   	SendMessage(HROUGE,BM_SETCHECK,BST_CHECKED,0);
   	SendMessage(HVERT,BM_SETCHECK,BST_CHECKED,0);
   	SendMessage(HBLEU,BM_SETCHECK,BST_CHECKED,0);

   	//== Demande Dialogue Modal a PhotoFiltre ============================
   	(*PStruct.TPrepareDialogue)(hDlg,DM_MODAL,dFALSE,dFALSE);

   	//== Creation de l'image a la bonne taille ============================
   	// Les Rectangles Delphi sont relatifs a l'origine
    // Si il n'y a pas de selection, le rectangle decrit l'image entiere
    Img.piWidth = PStruct.SelRect.right - PStruct.SelRect.left;
    Img.piHeight = PStruct.SelRect.bottom - PStruct.SelRect.top;

		(*PStruct.TCreateDBmp)(&Img);
		if ( Img.piBitmap == NULL)
			{(*PStruct.TEndFilter)();return(0);}

		IsInit=1; 		// Permetre l'affichage
		return(TRUE);
//== Fin de WM_INITDIALOG ============================

	//== WM_COMMAND ======================
	case WM_COMMAND:
      switch(wParam)
      //switch(LOWORD(wParam))
			{
   		//== BOUTON ANNULER ======================
   		case IDC_CANCEL:
   			EndDialog(hWin,FALSE);break;

			//== BOUTON OK ======================
   		case  IDC_OK:
				RetValue=1;
        EndDialog(hWin,TRUE);break;

   		//== CHECKBOX Rouge ======================
   		case IDC_ROUGE:
				if (SendMessage(HROUGE,BM_GETCHECK,0,0) == BST_UNCHECKED)
					Couche |= 1 ;
				else
					Couche &= 0xFFFFFFFE;
      	Affiche();
      	break;

   		//== CHECKBOX Vert ======================
   		case IDC_VERT:
				if (SendMessage(HVERT,BM_GETCHECK,0,0) == BST_UNCHECKED)
         Couche |= 2;
				else
					Couche &= 0xFFFFFFFD;
   			Affiche();
      	break;

  		//== CHECKBOX Bleu ======================
   		case IDC_BLEU:
				if (SendMessage(HBLEU,BM_GETCHECK,0,0) == BST_UNCHECKED)
         Couche |= 4;
				else
      		Couche &= 0xFFFFFFFB;
				Affiche();
      	break;

  		//== DEFAULT COMMAND PROCESS MESSAGE ======================
      default:
      	return(FALSE); // On traite pas le message

		//== FIN DE WM_COMMAND ======================
    } break; //==================================

  //== WM_CLOSE ======================
  case WM_CLOSE:
   	EndDialog(hWin,TRUE);

  //== DEFAUT GLOBAL PROCESS MESSAGE ======================
  default:
  	return(FALSE); // On traite pas le message

//*******************************************************************
	}//== FIN DE LA BOUCLE DE MESSAGE ======================
return(TRUE); // On envois au traitement les autres messages
}


//=========================================================================
// FONCTION D'AFFICHAGE (Pour info)
//=========================================================================
void Affiche(void)
{
UINT CptX,CptY,Tx;
UCHAR *Ptr;

if (!IsInit)
	return; 

//==== RESTAURATION DE L'IMAGE ET RECUPERATION DANS LE BUFFER D'IMAGE
TRestoreUndoBitmap(&PStruct);
(*PStruct.TGetSelBitmap)(Img.piBitmap);

//==== MODIFICATION DU BUFFER D'IMAGE
(*PStruct.TGetScanLineDBmp)(&Img,0);
Ptr = Img.piBuffer;
Tx = Img.piWidth * 3 ;
for (CptY=0; CptY < Img.piHeight ; CptY ++)
	{
	for (CptX=0; CptX < Tx ; CptX +=3)
   	{
    if ((Couche & 4))
    	Ptr[CptX]=0;	// Bleu
    if ((Couche & 2))
    	Ptr[CptX+1]=0;	// Vert
    if ((Couche & 1))
    	Ptr[CptX+2]=0;	// Rouge
    };
   Ptr -= (Img.piScanlineSize);
	};

//==== ACTUALISATION DE L'IMAGE
(*PStruct.TSetSelBitmap)(Img.piBitmap,SF_AUTO);
}

//=========================================================================
// FONCTIONS EXPORTEES
//=========================================================================
extern struct PluginHeader* DLLEXPORT RegisterPluginHeader(void)
{return(&PHeader);}
//-------------------------------------------------------------------------
extern struct PluginStruct* DLLEXPORT RegisterPluginStruct(void)
{return(&PStruct);}
//-------------------------------------------------------------------------
extern int DLLEXPORT RegisterCompatibility(void)
{return(NON_DELPHI);}
//-------------------------------------------------------------------------
extern HBITMAP DLLEXPORT RegisterPluginGlyph(void)
{return(LoadBitmap(hInstance,(LPTSTR)600));}
// OU => {return(LoadBitmap(hInstance,MAKEINTRESOURCE(600)));}


