//;********************************************************************
//; CONSTANTES PhotoFiltre
//;********************************************************************
#define	RGBColorCount = 256 * 256 * 256 ; 16 millions de couleurs
#define	MaxLongStr 256
#define	MaxShortStr 64

	// Compatibilit Delphi/Non Delphi
#define	DELPHI  1
#define	NON_DELPHI 2

  // type du plugin
#define	PT_FILTER 0
#define	PT_IMAGE 1
#define	PT_FILE_IMPORT 2
#define	PT_FILE_EXPORT 3
#define	PT_TOOL 4

// mode de dialogue
#define	DM_MODAL 0
#define	DM_PREVIEW 1
#define	DM_COLOR_PICKER 2

// flags de slection
#define	SF_AUTO 0
#define	SF_NONE 1

// flags pour la cration d'image
#define	IF_CREATE 0
#define	IF_FILE 1

// flags pour l'activation du menu
#define	MF_RGB_COLORS 0x00000001
#define	MF_INDEXED_COLORS 0x00000002
#define	MF_TRANSPARENT 0x00000004
#define	MF_NOT_TRANSPARENT 0x00000008
#define	MF_SELECTED 0x00000010
#define	MF_NOT_SELECTED 0x00000020
#define	MF_NEED_IMAGE 0x00000040
#define	MF_NEED_MORE_THAN_ONE_IMAGE 0x00000080

// test sur l'extension du fichier en cours
#define	MF_IMAGE_JPEG 0x00010000
#define	MF_IMAGE_GIF 0x00020000
#define	MF_IMAGE_PNG 0x00040000
#define	MF_IMAGE_BMP 0x00080000
#define	MF_IMAGE_TIFF 0x00100000
#define	MF_IMAGE_PFS 0x00200000

// === CONSTANTES FALSE/TRUE POUR DELPHI
#define	dFALSE 0
#define	NIL NULL

//;********************************************************************
//; DESCRIPTION DE LA STRUCTURE D'IMAGE
//;********************************************************************
typedef 		UINT 	DBITMAP;	// Objet Delphi TBitmap
typedef 		UINT 	DFORM;		// Objet Delphi TForm
struct		SIMAGE
	{
  UINT		piSize; 				// Taille de la structure en Octets
  UINT		piWidth;				// Taille X Utile en Pixels
  UINT		piHeight;				// Taille Y Utile en Pixels
  UINT		piWidthSize;		// Taille X Utile en Octets
  UINT		piScanlineSize;	// Taille D'une ScanLine complete en Octets
  UINT		piByteCount;		// NB D'octets par Pixels 
  UINT		piDataSize;			// Taille Totale du Buffer en Octets
  UCHAR*	piBuffer;				// Adresse Buffer
  DBITMAP	piBitmap;				// Pointeur Delphi TBitmap
  HBITMAP	piHandle;				// Pointeur HBitmap
	};

//;********************************************************************
//; DESCRIPTION DES STRUCTURES PHOTOFILTRE
//;********************************************************************
//;=== STRUCTURE D'ENTETE DU PLUGIN
struct		PluginHeader
	{
	char		Caption[MaxShortStr+1];
  char		Version[MaxShortStr+1];
  UINT		PluginType;
  char		Author[MaxShortStr+1];
  char		Commentaire[MaxShortStr+1];
	char		Reserved[MaxShortStr+1];
	UINT		Flags; 								
	};

//;=== STRUCTURE D'EXECUTION DU PLUGIN
struct		PluginStruct
	{
  // Compatibilit Niveau 1
  HWND 	MainHandle;
  INT		ImageExists;
  INT		Selected;
  RECT	SelRect;
  RECT	ImgRect;
  INT		XP_ThemesEnabled;
  INT (*TBeginFilter)(char* Message,int Sablier);
  INT (*TEndFilter)(void);
  INT (*TGetBitmap)(DBITMAP DelphiBitmap);
  INT (*TSetBitmap)(DBITMAP DelphiBitmap);
  INT (*TGetSelBitmap)(DBITMAP DelphiBitmap);
  INT (*TSetSelBitmap)(DBITMAP DelphiBitmap,UINT SelectOption);
  INT (*TGetTransparentColor)();
  INT (*TSetTransparentColor)(UINT Couleur);
  INT (*TGetColorCount)();
  INT (*TSetColorCount)(INT ColorCount);
  INT (*TNewImage)(DBITMAP DelphiBitmap,char* FileName,INT ImageOption,INT ColorCount,UINT TransColor);
  INT (*TShowForm)(DFORM TForm,INT DialogOption,INT MainFormCenter,INT CloseWaiting);
  INT (*TSetAlphaBlend)(INT AlphaRange);
  INT (*TDrawSelBorder)(INT Width,UINT Couleur,INT Antialias);
  INT (*TGetSelMask)(DBITMAP DelphiBitmap);
  void (*TResetSaveMenu)();
  INT (*TGetImgFileName)(char *PlPath,INT Taille);
  INT (*TGetExePath)(char *PlPath,INT Taille);
  INT (*TGetOpenPath)(char *PlPath,INT Taille);
  INT (*TGetSavePath)(char *PlPath,INT Taille);
  INT (*TGetPluginPath)(char *PlPath,INT Taille);
  INT (*TGetIniFile)(char *PlPath,INT Taille);
  INT (*TSetImgFileName)(char *PlPath);
  INT (*TGetBitmapByName)(DBITMAP DelphiBitmap,char* FileName);
  INT (*TGetThumb)(DBITMAP DelphiBitmap,UINT BkColor,
  			INT BorderSize,INT ShadowSize,UINT ShadowBkColor,RECT* R);
  INT (*TGetThumbByName)(DBITMAP DelphiBitmap,char* FileName,UINT BkColor,
  			INT BorderSize,INT ShadowSize,UINT ShadowBkColor,RECT* R);
  INT (*TEnumImages)(char* FileName,INT Width,INT Height,INT NbColor,UINT TransColor);
  // Compatibilit Niveau 2
  INT (*TPrepareDialogue)(HWND HandleF,INT DialogOption,INT MainFormCenter,INT CloseWaiting);
  INT (*TCreateDBmp)(struct SIMAGE *BitmapIn);
	INT (*TFreeDBmp)(struct SIMAGE *BitmapIn);
	HDC (*TReleaseHandleDBmp)(struct SIMAGE *BitmapIn);
	INT (*TGetScanLineDBmp)(struct SIMAGE *BitmapIn,UINT Row);
	INT	(*Reserve1)(void);
	INT	(*Reserve2)(void);
	INT	(*Reserve3)(void);
	INT	(*Reserve4)(void);
	INT	(*Reserve5)(void);
	};

//=========================================================================
// FONCTIONS AUXILIAIRES
//=========================================================================
void TRestoreUndoBitmap(struct PluginStruct* Pls);
void TRestoreUndoBitmap(struct PluginStruct* Pls)
{(*Pls->TSetBitmap)(NULL);}


