// Interface oriente C/C++ pour le dveloppement de plugin pour PhotoFiltre
// Version 1.0 / Avril 2004 / Copyright Benjamin FOURNIER
// Base sur la version Delphi 1.4 / Avril 2004 / Copyright Antonio Da Cruz
// La structure TPlgImage est propose par PF
// Merci de ne pas modifier les sources sans mon autorisation !

#ifndef PluginH
#define PluginH
#include "Plgint.h"

// pour SetHeaderPluginType
typedef enum {ptFilter, ptImage, ptFileImport, ptFileExport, ptTool} TPluginType;

// pour PlgSetSelBitmap
typedef enum {soAuto, soNone} TSelectionOption;

// pour NewImage
typedef enum {ioCreate, ioFile} TImageOption;

// pour ShowForm et PrepareDialog
typedef enum {doModal, doPreview, doColorPicker} TDialogOption;

// pour AlphaBlend
typedef short int TAlphaRange;

// pour l'activation du menu (SetHeaderMenuOptions)
typedef enum {
  moRGBColors = MF_RGB_COLORS,
  moIndexedColors = MF_INDEXED_COLORS,
  moTransparent = MF_TRANSPARENT,
  moNoTransparent = MF_NOT_TRANSPARENT,
  moSelected = MF_SELECTED,
  moNotSelected = MF_NOT_SELECTED,
  moNeedImage = MF_NEED_IMAGE,
  moNeedMoreThanOneImage = MF_NEED_MORE_THAN_ONE_IMAGE,
  moImageJpeg = MF_IMAGE_JPEG,
  moImageGif = MF_IMAGE_GIF,
  moImagePng = MF_IMAGE_PNG,
  moImageBmp = MF_IMAGE_BMP,
  moImageTiff = MF_IMAGE_TIFF,
  moImagePfs = MF_IMAGE_PFS} TMenuOption;

// pour GetImgInfosByName
typedef struct
{
  char FileName[MaxLongStr + 1];
  int Width;
  int Height;
  int ColorCount;
  TDColor TransparentColor;
} TImageInfos;

// 16 millions de couleurs
#define RGBColorCount 0x1000000;

// rcupration de la langue en cours
char *GetLanguageCode(char Code[3]);
char *GetLanguageStr();

// initialisation de l'entte
void SetHeaderCaption(char *Caption);
void SetHeaderVersion(char *Version);
void SetHeaderPluginType(TPluginType PluginType);
void SetHeaderAuthor(char *Author);
void SetHeaderComment(char *Comment);
void SetHeaderMenuOptions(TMenuOption Options);

// ces fonctions sont  utiliser uniquement dans la fonction Excute
HWND MainHandle();
BOOL ImageExists();
BOOL IsSelected();
RECT GetSelRect();
int GetSelWidth();
int GetSelHeight();
RECT GetImgRect();
int GetImgWidth();
int GetImgHeight();
BOOL XP_ThemesEnabled();
void BeginFilter(char *Msg, BOOL ChangeCursor);
void EndFilter();
BOOL GetBitmap(PPlgImage pImg);
BOOL SetBitmap(PPlgImage pImg);
BOOL RestoreUndoBitmap();
BOOL GetSelBitmap(PPlgImage pImg);
BOOL SetSelBitmap(PPlgImage pImg, TSelectionOption Option);
TDColor GetTransparentColor();
BOOL SetTransparentColor(TDColor Color);
int GetColorCount();
int SetColorCount(int ColorCount);
BOOL NewImage(PPlgImage pImg, char *FileName, TImageOption Option,
  int ColorCount, TDColor TransColor);
void ShowForm(TDForm* Form, TDialogOption Option, BOOL MainFormCenter,
  BOOL CloseWaiting);
BOOL SetAlphaBlend(TAlphaRange Alpha);
BOOL DrawSelBorder(int Width, TDColor Color, BOOL Antialias);
BOOL GetSelMask(PPlgImage pImg);
void ResetSaveMenu();
char *GetImgFileName(char Buffer[MaxLongStr + 1]);
char *GetExePath(char Buffer[MaxLongStr + 1]);
char *GetOpenPath(char Buffer[MaxLongStr + 1]);
char *GetSavePath(char Buffer[MaxLongStr + 1]);
char *GetPluginPath(char Buffer[MaxLongStr + 1]);
char *GetIniFile(char Buffer[MaxLongStr + 1]);
BOOL SetImgFileName(char *FileName);
BOOL GetBitmapByName(PPlgImage pImg, char *FileName);
BOOL GetThumb(PPlgImage pImg, TDColor BkColor, int BorderSize, int ShadowSize,
  TDColor ShadowBkColor, RECT *R);
BOOL GetThumbByName(PPlgImage pImg, char *FileName, TDColor BkColor,
  int BorderSize, int ShadowSize, TDColor ShadowBkColor, RECT *R);
BOOL EnumImages(TEnumImageProc EnumImageProc);
BOOL GetImgInfosByName(char *FileName, TImageInfos *ImageInfos);

// compatibilit de niveau >= 2
void PrepareDialog(HWND Handle, TDialogOption Option, BOOL MainFormCenter,
  BOOL CloseWaiting);
BOOL CreateDBmp(PPlgImage pImg);
BOOL FreeDBmp(PPlgImage pImg);
BOOL ReleaseHandleDBmp(PPlgImage pImg);
void *GetScanLineDBmp(PPlgImage pImg, int Row);
BOOL CheckPluginFunc(BOOL RetVal);
void ShowPluginErrorMsg();

#endif
