unit Params;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TParamsForm = class(TForm)
    BtnCancel: TButton;
    BtnOk: TButton;
    Image: TImage;
    ListBox: TListBox;
    BtnThumb: TButton;
    Label1: TLabel;
    procedure BtnOkClick(Sender: TObject);
    procedure BtnCancelClick(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure BtnThumbClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ListBoxDblClick(Sender: TObject);
  private
    procedure FindImages;
    procedure FindThumb;
    procedure DoAction;
  public
    DialogResult: Boolean;
  end;

var
  ParamsForm: TParamsForm;

implementation

uses
  Plugin;

{$R *.dfm}

procedure TParamsForm.FormShow(Sender: TObject);
begin
  ActiveControl := BtnOk;
  FindImages;
end;

function EnumImageProc(pFileName: PChar; Width, Height,
  NbColors: Integer; TransColor: TColor): LongBool; stdcall;
begin
  Result := ParamsForm.ListBox.Items.Add(Format('%s (%dx%dx%d)',
    [pFileName, Width, Height, NbColors])) >= 0;
end;

procedure TParamsForm.FindImages;
begin
  EnumImages(EnumImageProc);
end;

procedure TParamsForm.FindThumb;
var
  R: TRect;
  S: string;
begin
  if ListBox.ItemIndex < 0 then Exit;
  // inialise le bitmap
  Image.Picture.Bitmap.Width := Image.Width;
  Image.Picture.Bitmap.Height := Image.Height;
  Image.Picture.Bitmap.PixelFormat := pf24bit;
  // rcupre la vignette
  S := ListBox.Items[ListBox.ItemIndex];
  S := Copy(S, 1, Pos('(', S) - 2);
  GetThumbByName(Image.Picture.Bitmap, S, clWhite, 4, 4, Color, R);
  Image.Update;
end;

procedure TParamsForm.DoAction;
begin
  try
    BeginFilter;
  finally
    EndFilter;
  end;
end;

procedure TParamsForm.BtnThumbClick(Sender: TObject);
begin
  FindThumb;
end;

procedure TParamsForm.ListBoxDblClick(Sender: TObject);
begin
  FindThumb;
end;

procedure TParamsForm.BtnOkClick(Sender: TObject);
begin
  DoAction;
  DialogResult := True;
  Close;
end;

procedure TParamsForm.BtnCancelClick(Sender: TObject);
begin
  Close;
end;

// Actions via le clavier (KeyPreview  True)
procedure TParamsForm.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #27 then Close
  else if Key = #13 then BtnOkClick(Sender);
end;

end.
