// Plugin d'exemple pour PhotoFiltre : Cration dynamique d'une image
// en mode transparent
// Copyright (c) Antonio DA CRUZ - Avril 2004
// Ce plugin est de type Importation
// Il ne doit en aucun cas modifier une image en cours !
// Renommez le fichier compil 'NewImg.dll' en 'NewImg.pfl' et placez-le
// dans le dossier 'Plugins' de PhotoFiltre

library NewImg;

uses
  Windows, Graphics, Dialogs, Plugin;

{$R *.res}

function RegisterPluginHeader: PPluginHeader; stdcall;
begin
  SetHeaderCaption('Nouvelle image');
  SetHeaderVersion('1.0');
  SetHeaderPluginType(ptFileImport);
  SetHeaderAuthor('Antonio Da Cruz');
  SetHeaderComment('Plugin d''exemple pour PhotoFiltre');
  Result := PtrPlgHeader;
end;

function RegisterPluginStruct: PPluginStruct; stdcall;
begin
  Result := PtrPlgStruct;
end;

function RegisterCompatibility: Integer; stdcall;
begin
  Result := 1;
end;

procedure DoAction;
var
  Bitmap: TBitmap;
begin
  Bitmap := TBitmap.Create;
  try
    BeginFilter;
    Bitmap.PixelFormat := pf24bit;
    Bitmap.Width := 640;
    Bitmap.Height := 480;
    with Bitmap.Canvas do
    begin
      Pen.Width := 2;
      Brush.Color := clBlue;
      Rectangle(30, 30, 200, 200);
      Ellipse(400, 200, 600, 400);
    end;
    // mode 16 couleurs avec transparence
    CheckPluginFunc(NewImage(Bitmap, '', ioCreate, 16, clBlue));
  finally
    Bitmap.Free;
    EndFilter;
  end;
end;

function Execute: Integer; stdcall;
begin
  try
    DoAction;
    Result := 1;
  except
    Result := 0;
    ShowPluginErrorMsg;
  end;
end;

exports
  RegisterCompatibility name 'RegisterCompatibility',
  RegisterPluginHeader name 'RegisterPluginHeader',
  RegisterPluginStruct name 'RegisterPluginStruct',
  Execute name 'Execute';

begin
end.
