// Inversion des couches RVB
// Copyright (c) Antonio DA CRUZ - Avril 2004
// Ce plugin est de type Filtre
// Renommez le fichier compil 'SwapRGB.dll' en 'SwapRGB.pfl' et placez-le
// dans le dossier 'Plugins' de PhotoFiltre

library SwapRGB;

uses
  Windows,
  Graphics,
  Forms,
  Plugin,
  Params in 'Params.pas' {ParamsForm};

{$R *.res}

function RegisterCompatibility: Integer; stdcall;
begin
  Result := 1;
end;

function RegisterApplication: PApplication; stdcall;
begin
  Result := @Application;
end;

function RegisterPluginHeader: PPluginHeader; stdcall;
begin
  SetHeaderCaption('Inversion RVB...');
  SetHeaderVersion('1.0');
  SetHeaderPluginType(ptFilter);
  SetHeaderAuthor('Antonio Da Cruz');
  SetHeaderComment('Inversion des couches RVB');
  Result := PtrPlgHeader;
end;

function RegisterPluginStruct: PPluginStruct; stdcall;
begin
  Result := PtrPlgStruct;
end;

function RegisterPluginGlyph: HBitmap; stdcall;
begin
  Result := LoadBitmap(HInstance, PChar('GLYPH'));
end;

function Execute: Integer; stdcall;
begin
  try
    ParamsForm := TParamsForm.Create(Application);
    try
      ShowForm(ParamsForm, doPreview);
      Result := Ord(ParamsForm.DialogResult);
    finally
      ParamsForm.Free;
    end;
  except
    Result := 0;
  end;
end;

exports
  RegisterCompatibility name 'RegisterCompatibility',
  RegisterApplication name 'RegisterApplication',
  RegisterPluginHeader name 'RegisterPluginHeader',
  RegisterPluginStruct name 'RegisterPluginStruct',
  RegisterPluginGlyph name 'RegisterPluginGlyph',  
  Execute name 'Execute';

begin
end.
