// Affichage de type XP pour les version de Delphi <= 7
// (Delphi 7 gre correctement l'affichage XP)
// Ncessite le composant ThemeManager (C) 2001-2002 Mike Lischke
// Copyright (c) Antonio DA CRUZ - Avril 2004
// Ce plugin est de type Outil
// Renommez le fichier compil 'ThemeXP.dll' en 'ThemeXP.pfl' et placez-le
// dans le dossier 'Plugins' de PhotoFiltre

library ThemeXP;

uses
  Windows,
  Graphics,
  Forms,
  Plugin,
  ThemeMgr,
  Params in 'Params.pas' {ParamsForm},  
  Params2 in 'Params2.pas' {Params2Form};

{$R *.res}

function RegisterCompatibility: Integer; stdcall;
begin
  Result := 1;
end;

function RegisterApplication: PApplication; stdcall;
begin
  Result := @Application;
end;

function RegisterPluginLanguage: PPluginLanguage; stdcall;
begin
  Result := PtrPlgLanguage;
end;

function RegisterPluginHeader: PPluginHeader; stdcall;
begin
  SetHeaderCaption('Affichage XP');
  SetHeaderVersion('1.0');
  SetHeaderPluginType(ptTool);
  SetHeaderAuthor('Antonio Da Cruz');
  SetHeaderComment('Exemple d''affichage de type XP');
  Result := PtrPlgHeader;
end;

function RegisterPluginStruct: PPluginStruct; stdcall;
begin
  Result := PtrPlgStruct;
end;

function Execute: Integer; stdcall;
var
  ThemeManager: TThemeManager;
begin
  try
    // Cration des fiches
    ParamsForm := TParamsForm.Create(Application);
    Params2Form := TParams2Form.Create(Application);
    // ThemeManager est cr dynamiquement seulement si ncessaire
    if XP_ThemesEnabled then 
    begin
      ThemeManager := TThemeManager.Create(Application);
      ThemeManager.CollectForms(ParamsForm);
      ThemeManager.CollectForms(Params2Form);
    end
    else ThemeManager := nil;
    try
      // Affiche la fiche principale
      ShowForm(ParamsForm, doModal);
      Result := Ord(ParamsForm.DialogResult);
    finally
      ThemeManager.Free;
      ParamsForm.Free;
      Params2Form.Free;
    end;
  except
    Result := 0;
  end;
end;

exports
  RegisterCompatibility name 'RegisterCompatibility',
  RegisterApplication name 'RegisterApplication',
  RegisterPluginLanguage name 'RegisterPluginLanguage',
  RegisterPluginHeader name 'RegisterPluginHeader',
  RegisterPluginStruct name 'RegisterPluginStruct',
  Execute name 'Execute';

begin
end.
